<?php

namespace Relatione\Logic;

use \Relatione\Logic\Exception\ExceptionContato;
use \Relatione\Logic\Exception\ExceptionProspect;
use \Geral\Entities\Prospect;
use \Geral\Entities\Cliente;
use \Geral\Entities\Fornecedor;
use \Geral\Util\NovoCodigo;
use \Relatione\Entities\Evolcont;
use \Relatione\Entities\Filacontato;
use \Academico\Entities\Endeprospect;
use \Geral\Util\DateUtil;
use \Geral\Util\Ambiente;
use Setforms2\Shared\Registry;


/**
 * Created by JetBrains PhpStorm.
 * User: marcellichtnow
 * Date: 01/04/13
 * Time: 09:19
 * To change this template use File | Settings | File Templates.
 */
class ContatoLogic
{


    /**
     * Deleta arquivo anexado selecionado
     * @param string $field_list campo que mostra os arquivos anexados
     */
    public static function deletaAnexo($nrorg, $filial, $nrContato, $idAnexo, $dthora, $diretorio, $operador, $nomeArquivos) {
//        $prefixoNomeArquivo = self::preparaNomeAnexo($nrorg, $filial, $nrContato, $dthora);

        //abre o diretorio
//        $ponteiro  = opendir($diretorio);

        $caminho = realpath($diretorio).DIRECTORY_SEPARATOR;

        foreach($nomeArquivos as $nome){

            $caminhoCompleto = $caminho.$nome;
            chmod($caminhoCompleto,0775);
            unlink($caminhoCompleto);

        }
        //monta os vetores com os itens encontrados na pasta
//        while (($nome_itens = readdir($ponteiro)) !== false) {
//            $strPos = strpos($nome_itens, $prefixoNomeArquivo);
//
//            if ($strPos !== false) {
//
//                unlink($diretorio.DIRECTORY_SEPARATOR.$nome_itens);
//            }
//        }

//      //percorre o vetor para fazer a separacao entre arquivos e pastas
//      foreach ($itens as $listar) {
//
//          //retira "./" e "../" para que retorne apenas arquivos
//          if ($listar!="." && $listar!=".."){
//
//                  $arquivos[]=$listar;
//          }
//      }

//        if ($itens === null) {
        if ($idAnexo !== 'N') {
            $dt = DateUtil::getDataAtual();
            $dthora = DateUtil::getDataDeString($dthora, DateUtil::FORMATO_BRASILEIRO_DATAHORA);

            $connection = Registry::getEntityManager();
            $connection->beginTransaction();

            try {
                /** @var $objEvolCont Evolcont */
                $objEvolCont = Evolcont::getObject(
                    array('nrorg' => $nrorg, 'cdfilial' => $filial, 'dthrevolcont' => $dthora,
                        'nrcontato' => $nrContato)
                );

                $objEvolCont->atualizaIdentificadorAnexo($nrorg, Evolcont::SEM_ANEXO, $dt, $operador);

                $connection->flush();
                $connection->commit();
            } catch (\Exception $e) {
                $connection->rollback();
                throw $e;
            }
        }

//        }

        return true;
    }


    public static function preparaNomeAnexo($nrorg, $filial, $nrContato, $dthora){
        //Pega a hora e convete para o padrao YYYY/MM/DD, de forma a manter uma ordenacao alfabetica consistente
        $dthoraTrat = explode('/', substr($dthora, 0, 10));
        $dthoraTrat = $dthoraTrat[2].$dthoraTrat[1].$dthoraTrat[0];

        //Pega a data no novo formato e concatena com a hora
        $dthoraTrat = $dthoraTrat.substr($dthora, 11);

        //Retira tudo que não for numero
        $dthoraTrat = preg_replace('/\D/', "", $dthoraTrat);

        //$dir_destino = realpath(dirname(__FILE__).'/../../');
        //$dir_destino = $diretorio;
        $nome_arquivo = $nrorg.'_'.$filial.'_'.$nrContato.'_'.$dthoraTrat;

        //tk_clear_file_list('FILE');

        return $nome_arquivo;
    }


    /**    ok
     * Anexa arquivos no diretorio parametrizado.
     *
     * @param string $dir_origem  Diretorio de origem.
     * @param string $dir_destino Diretorio de destino.
     * @param string $nome_arquivo Nome do Arquivo.
     *
     * @return boolean
     */
    public static function incluiAnexosEvolucao($nrorg, $filial, $nrContato, $dthora, $dir_origem, $dir_destino, $operador) {
        try {

            $nome_arquivo = self::preparaNomeAnexo($nrorg, $filial, $nrContato, $dthora);

            $nome = tk_get_uploaded_file_name();
            $nome_arquivo = $nome_arquivo.'_'.$nome;
            $nome_arquivo_novo = strtr(utf8_decode($nome_arquivo), utf8_decode("áàãâéêíóôõúüçÁÀÃÂÉÊÍÓÔÕÚÜÇ "), "aaaaeeiooouucAAAAEEIOOOUUC_");
            $nome_arquivo_novo = utf8_encode($nome_arquivo_novo);

            rename($dir_origem.DIRECTORY_SEPARATOR.$nome, $dir_destino.DIRECTORY_SEPARATOR.$nome_arquivo_novo);
            chmod($dir_destino.DIRECTORY_SEPARATOR.$nome_arquivo_novo, 0775);

            $dt = DateUtil::getDataAtual();
            $dthora = DateUtil::getDataDeString($dthora, DateUtil::FORMATO_BRASILEIRO_DATAHORA);

            $connection = Registry::getEntityManager();
            $connection->beginTransaction();

            try {
                /** @var $objEvolCont Evolcont */
                $objEvolCont = Evolcont::getObject(
                    array('nrorg' => $nrorg, 'cdfilial' => $filial, 'dthrevolcont' => $dthora,
                        'nrcontato' => $nrContato)
                );
                if(empty($objEvolCont)){
                    tk_warning("Salvar registro antes de anexar arquivos.");
                    return false;
//                    \Windows\Ron20000\Ron2000002\Facade::anexarArquivos();
                }

                $objEvolCont->atualizaIdentificadorAnexo($nrorg, Evolcont::COM_ANEXO, $dt, $operador);

                $connection->flush();
                $connection->commit();
            } catch (\Exception $e) {
                $connection->rollback();
                throw $e;
            }

            return true;
        } catch (\Exception $e) {
            tk_warning($e->getMessage());
            return false;
        }
    }

    public static function insereEndProsp($prospect, $nrorg, $operador){
        $endProsp = Endeprospect::findOneByCdprospectAndNrorg($prospect, $nrorg);

        if (empty($endProsp)) {
            $connection = \Setforms2\Shared\Registry::getEntityManager();
            $connection->beginTransaction();

            try {
                $dtInclusao = \Geral\Util\DateUtil::getDataAtual();
                /** @var $objEndProspect \Academico\Entities\Endeprospect */
                $objEndProspect = new \Academico\Entities\Endeprospect();
                $objEndProspect-> insereEndereco($nrorg, $prospect,'0055','MG','4123',$dtInclusao,$operador);

                $connection->flush();
                $connection->commit();
            } catch (\Exception $e) {
                $connection->rollback();
                throw $e;
            }

        }
    }


    public static function insereAgendaContato(
        $data, $prioridade, $nrParcNegocio, $nrContato, $cdinterloc,
        $dsfilacontato, $cdOperador,$nrOrg, $cdprospect,$dtAudit, $cdOperAudit
    ){
        $connection = \Setforms2\Shared\Registry::getEntityManager();
        $connection->beginTransaction();

        try {
            $seq = NovoCodigo::geraCodigo($nrOrg, 'FILACONTATO', 1, 20);
            $filaContato = new Filacontato();
            $filaContato->insereFilaContato(
                $data, $prioridade, $nrParcNegocio, $nrContato, $cdinterloc,
                $dsfilacontato, $cdOperador,$nrOrg, $cdprospect,$dtAudit, $cdOperAudit, $seq
            );

            $connection->commit();
            return true;
        } catch (\Exception $e) {
            $connection->rollback();
            throw $e;
        }

    }


    public static function retornaNovoCodigoSeqEvol($nrorg, $contato){
        /** @var $max Evolcont */
        $max = Evolcont::getObjectByWhere(
            'NRORG = ? AND NRCONTATO = ?', array($nrorg, $contato), 'NRSEQEVOLCON DESC'
        );

        if ($max) {
            $seqMax = str_pad($max->getNrseqevolcon(), 2, "0", STR_PAD_LEFT);
        } else {
            $seqMax = str_pad(0, 2, "0", STR_PAD_LEFT);
        }

        return $seqMax;
    }


    public static function retornaDadosContato($nrContato, $nrOrg){
        $resultado = \Geral\Entities\Contato::getObjectByWhere(
            'NRCONTATO = ? AND NRORG = ?',
            array(
                $nrContato,
                $nrOrg,
            )
        );

        return $resultado;
    }


    public static function retornaContatoPeloParceiro($nrParcNegocio, $nrOrg){


        $resultado = \Geral\Entities\Contato::getObjectByWhere (
            'NRPARCNEGOCIO = ? AND NRORG = ?',
            array(
                $nrParcNegocio,
                $nrOrg,
            ),
            'NRCONTATO DESC'
        );
        return $resultado;

    }


    public static function validaContato($nrOrg, $nrContato, $situacao, $nrParc){
        if (empty($nrContato) === true) {
            ExceptionContato::erroRegistroNaoSelecionado();
        }

        if ($situacao === 'C') {
            ExceptionContato::erroContatoConcluido();
        }

        if ($nrParc === false) {
            ExceptionContato::erroContatoSemParceiro();
        }

        $resultVerrifContato = self::retornaDadosContato($nrContato,$nrOrg);
        if (empty($resultVerrifContato) === true) {
            ExceptionContato::erroContatoNaoIncluido();
        }

        return true;
    }


    public static function retornaProspect($nrOrg, $nrParceiro){
        $objProspect = Prospect::getObjectByWhere('NRORG = ? AND NRPARCNEGOCIO = ?', array($nrOrg, $nrParceiro));
        if ($objProspect instanceof Prospect) {
            return $objProspect->getCdprospect();
        }

        return null;
    }


    public static function retornaCliente($nrOrg, $nrParceiro){
        $objCliente = Cliente::getObjectByWhere('NRORG = ? AND NRPARCNEGOCIO = ?', array($nrOrg, $nrParceiro));
        if ($objCliente instanceof Cliente) {
            return $objCliente->getCdcliente();
        }

        return null;
    }


    public static function retornaFornecedor($nrOrg, $nrParceiro){
        $objFornecedor = Fornecedor::getObjectByWhere('NRORG = ? AND NRPARCNEGOCIO = ?', array($nrOrg, $nrParceiro));
        if ($objFornecedor instanceof Fornecedor) {
            return $objFornecedor->getCdforneced();
        }

        return null;
    }


    public static function retornaMascaraInscProspect($nrInscValue){
        $quantidade = strlen($nrInscValue);

        switch ($quantidade) {
            case 11:
                $tpInsc = Prospect::PESSOA_FISICA;
                break;
            case 14:
                $tpInsc = Prospect::PESSOA_JURIDICA;
                break;
            case 5:
                $tpInsc = Prospect::OUTROS;
                break;
            default:
                $tpInsc = Prospect::GERAL;
        }

        return $tpInsc;
    }


    public static function validaNumeroInscricao($nrInsc, $tpInsc){
        if ($nrInsc) {
            switch($tpInsc) {
                case Prospect::PESSOA_FISICA:
                    $validate = ProspectLogic::validateCPF($nrInsc);
                    if ($validate === 0) {
                        ExceptionProspect::erroCpfInvalido();
                    }
                    break;
                case Prospect::PESSOA_JURIDICA:
                    $validate = ProspectLogic::validateCNPJ($nrInsc);
                    if ($validate == 0) {
                        ExceptionProspect::erroCnpjInvalido();
                    }
                    break;
                case Prospect::OUTROS:
                    $size = strlen($nrInsc);
                    if ($size < 5) {
                        $nrInsc = str_pad($nrInsc, 5, '0', STR_PAD_LEFT);
                    }
                    break;
                case Prospect::GERAL:
                    $nrInsc = str_pad($nrInsc, 20, '0', STR_PAD_LEFT);
            }

            return $nrInsc;
        }

        return false;
    }

    public static function retornaModeloCasoPararelatione()//Verifica se há um modelo de caso inserido na tabela PARARELATIONE
    {
        $sql = "SELECT NRSEQMODELOCASO FROM PARARELATIONE";
        $retorno = \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAll($sql);
        if (!empty($retorno))
            return $retorno[0]['NRSEQMODELOCASO'];
        else
            return null;
    }

    public static function retornaDadosModeloCaso($nrorg)//Retorna dados da tabela CRM_MODELOCASO
    {
        $nrseqmodelocaso = self::retornaModeloCasoPararelatione();
        if (!empty($nrseqmodelocaso))
        {
            $sql = "SELECT CDMNEMONICOCASO,     NRSITUACAOABERTURA,     IDGERAFATURCASO,
                           IDGERAEVOLUCAO,      NRTPCONTATOEVOLPADR,    CDMOTIVOEVOLPADR,
                           DSEVOLUCAOPADR,      IDGERAFATUREVOL
                      FROM CRM_MODELOCASO
                     WHERE NRSEQMODELOCASO = ".$nrseqmodelocaso."
                       AND NRORG = ".$nrorg;
            $retorno = \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAll($sql);
            return $retorno[0];
        }
        else
            return null;
    }

    public static function geraCodigoCaso($nrorg)//Gera o código do caso de acordo com os mnemonicos definidos na tela Modelo de Caso.
    {
        $modelo = self::retornaDadosModeloCaso($nrorg);
        $contatocd = \Geral\Util\NovoCodigo::geraCodigo($nrorg,'CONTATOCD',1,10,true);

        if (!empty($modelo))
        {
            $cdmnemonicocaso = $modelo['CDMNEMONICOCASO'];
            $data = tk_get_field_value('DTHRCONTATO');
            $data = \Geral\Util\DateUtil::getDataDeString($data,\Geral\Util\DateUtil::FORMATO_BRASILEIRO_DATAHORA);
            $mes = \Geral\Util\DateUtil::getMes($data);
            $ano = \Geral\Util\DateUtil::getAno($data);

            if (!empty($cdmnemonicocaso))
            {
                $cdcaso = str_replace('[SEQ]',$contatocd,$cdmnemonicocaso);
                $cdcaso = str_replace('[MES]',$mes,$cdcaso);
                $cdcaso = str_replace('[ANO]',$ano,$cdcaso);
            }
            else
            {
                $cdcaso = $contatocd."_".$mes."/".$ano;
            }
        }
        else
        {
            $data = \Geral\Util\DateUtil::getDataAtual();
            tk_var_dump($data);
            $mes = \Geral\Util\DateUtil::getMes($data);
            $ano = \Geral\Util\DateUtil::getAno($data);
            $cdcaso = $contatocd."_".$mes."/".$ano;
        }
        return $cdcaso;
    }

    public static function buscaParceiroInterlocutor($nrparcnegrelac, $nrorg)//Busca o(s) Parceiro(s) de Negócio do qual o operador logado é Interlocutor.
    {
        $sql = "SELECT NRPARCNEGOCIO
                  FROM VIEW_INTERPARC
                 WHERE NRTIPORELACIONA = 25
                   AND NRPARCNEGRELAC  = :NRPARCNEGRELAC
                   AND NRORG           = :NRORG
                   AND IDATIVO         = 'S'";
        $params = array(
            "NRPARCNEGRELAC"=>$nrparcnegrelac,
            "NRORG"=>$nrorg);
        $retorno = \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAll($sql, $params);
        if (!empty($retorno)) {
            $retorno2 = array();
            foreach($retorno as $values) {
                $retorno2[] = $values['NRPARCNEGOCIO'];
            }
            return $retorno2;
        }
        else
            return null;
    }

    public static function buscaOperadorResponsavel($nrseqcontato, $nrorg)
    {
        $prioridade = self::buscaPrioridade($nrorg);
        if (count($prioridade) != 3)
            return "PRIORIDADE";//Cadastro de prioridade incompleto para o processo "Direcionamento de Caso".
        else
        {
            $sql = "SELECT NRPARCNEGOCIO, CDSISTEMA, CDMOTICONT
                      FROM CONTATO
                     WHERE NRSEQCONTATO = ".$nrseqcontato."
                       AND NRORG        = ".$nrorg;
            $retorno = \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAll($sql);

            $valores = array(
                "NRPARCABERTURA"    => $retorno[0]['NRPARCNEGOCIO'],
                "CDSISTEMAABERTURA" => $retorno[0]['CDSISTEMA'],
                "CDMOTICONABERTURA" => $retorno[0]['CDMOTICONT']);
            
            return self::buscaOperadorDirecionamento($prioridade, $valores);
        }
    }

    public static function buscaPrioridade($nrorg)
    {
        $sql = "SELECT DECODE(CDTABLE,'PARCNEGOCIO','NRPARCABERTURA',DECODE(CDTABLE,'SISTEMA','CDSISTEMAABERTURA',DECODE(CDTABLE,'MOTICONT','CDMOTICONABERTURA'))) AS CAMPO
                  FROM GER_PRIORIPROCESSO
                 WHERE NRSEQPROCESSO = 1
                   AND NRORG = ".$nrorg."
                   AND IDATIVO = 'S'
                 ORDER BY NRPRIORIDADE";
        $retorno = \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAll($sql);
        if (empty($retorno))
        {
            $sql = "SELECT DECODE(CDTABLE,'PARCNEGOCIO','NRPARCABERTURA',DECODE(CDTABLE,'SISTEMA','CDSISTEMAABERTURA',DECODE(CDTABLE,'MOTICONT','CDMOTICONABERTURA'))) AS CAMPO
                      FROM GER_PRIORIPROCESSO
                     WHERE NRSEQPROCESSO = 1
                       AND NRORG = 0
                     ORDER BY NRPRIORIDADE";
            $retorno = \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAll($sql);
        }
        return $retorno;
    }

    public static function buscaOperadorDirecionamento($prioridades, $valores)
    {
        $prioridade0 = $prioridades[0]['CAMPO'];
        $prioridade1 = $prioridades[1]['CAMPO'];
        $prioridade2 = $prioridades[2]['CAMPO'];

        $sql = "SELECT CDOPERDIRECIONADO, ".$prioridade0.", ".$prioridade1.", ".$prioridade2."
                  FROM CRM_DIRECIONAMENTOCASO
                 WHERE (".$prioridade0." = '".$valores[$prioridade0]."' OR ".$prioridade0." IS NULL)
                   AND (".$prioridade1." = '".$valores[$prioridade1]."' OR ".$prioridade1." IS NULL)
                   AND (".$prioridade2." = '".$valores[$prioridade2]."' OR ".$prioridade2." IS NULL)";
        $retorno = \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAll($sql);
        $operadores = array();

        for ($i=0; $i<count($retorno); $i++){
            $operadores[] = $retorno[$i]['CDOPERDIRECIONADO'];
            unset($retorno[$i]['CDOPERDIRECIONADO']);
        }
        
        //Verifica se existe um operador para o direcionamento com os 3 parâmetros preenchidos.
        $indiceOperador = array_search(array($prioridade0 => $valores[$prioridade0], $prioridade1 => $valores[$prioridade1], $prioridade2 => $valores[$prioridade2]), $retorno);
        
        if ($indiceOperador !== false)
            return $operadores[$indiceOperador];
        else
        {   
            //Verifica se existe um operador para o direcionamento com os 2 parâmetros mais prioritários preenchidos.
            $indiceOperador = array_search(array($prioridade0 => $valores[$prioridade0], $prioridade1 => $valores[$prioridade1], $prioridade2 => null), $retorno);
            if ($indiceOperador !== false)
                return $operadores[$indiceOperador];
            else
            {
                //Verifica se existe um operador para o direcionamento com o 1º e o 3º parâmetro mais prioritário preenchidos.
                $indiceOperador = array_search(array($prioridade0 => $valores[$prioridade0], $prioridade1 => null, $prioridade2 => $valores[$prioridade2]), $retorno);
                if ($indiceOperador !== false)
                    return $operadores[$indiceOperador];
                else
                {
                    //Verifica se existe um operador para o direcionamento com o 2º e o 3º parâmetro mais prioritário preenchidos.
                    $indiceOperador = array_search(array($prioridade0 => null, $prioridade1 => $valores[$prioridade1], $prioridade2 => $valores[$prioridade2]), $retorno);
                    if ($indiceOperador !== false)
                        return $operadores[$indiceOperador];
                    else
                    {
                        //Verifica se existe um operador para o direcionamento com apenas o 1º parâmetro mais prioritário preenchido.
                        $indiceOperador = array_search(array($prioridade0 => $valores[$prioridade0], $prioridade1 => null, $prioridade2 => null), $retorno);
                        if ($indiceOperador !== false)
                            return $operadores[$indiceOperador];
                        else
                        {
                            //Verifica se existe um operador para o direcionamento com apenas o 2º parâmetro mais prioritário preenchido.
                            $indiceOperador = array_search(array($prioridade0 => null, $prioridade1 => $valores[$prioridade1], $prioridade2 => null), $retorno);
                            if ($indiceOperador !== false)
                                return $operadores[$indiceOperador];
                            else
                            {
                                //Verifica se existe um operador para o direcionamento com apenas o 3º parâmetro mais prioritário preenchido.
                                $indiceOperador = array_search(array($prioridade0 => null, $prioridade1 => null, $prioridade2 => $valores[$prioridade2]), $retorno);
                                if ($indiceOperador !== false)
                                    return $operadores[$indiceOperador];
                                else
                                {
                                    //Verifica se existe um operador para o direcionamento sem parâmetros preenchidos (operador padrão).
                                    $indiceOperador = array_search(array($prioridade0 => null, $prioridade1 => null, $prioridade2 => null), $retorno);
                                    if ($indiceOperador !== false)
                                        return $operadores[$indiceOperador];
                                    else
                                        return null;
                                }
                            }
                        }
                    }
                }
            }
        }
    }

    public static function verificaPerfilAtividade()
    {
        $operadorLogado = \Geral\Util\Ambiente::getCdOperador();
        $sql = 'SELECT PERFILATIV.IDDASHPADR, PERFILATIV.NRSEQPERFATIV
                  FROM CRM_PERFILATIV PERFILATIV, CRM_PERFIOPER PERFIOPER 
                 WHERE PERFILATIV.NRSEQPERFATIV = PERFIOPER.NRSEQPERFATIV
                   AND PERFIOPER.CDOPERADOR = :CDOPERADOR';
        $params = array('CDOPERADOR' => $operadorLogado);
        $retorno = \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAll($sql, $params);
        return $retorno;
    }
    
}